MyGUI: MyGUI::ComboBox Class Reference

MyGUI 3.2.2

Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions
MyGUI::ComboBox Class Reference

ComboBox properties.
Skin childs. ComboBox widget description should be here. More...

`#include <MyGUI_ComboBox.h>`

Inheritance diagram for MyGUI::ComboBox:
[legend]

## Public Types
typedef RTTIBase | Base
typedef ComboBox | RTTIBase
Public Types inherited from MyGUI::EditBox
typedef RTTIBase | Base
typedef EditBox | RTTIBase
Public Types inherited from MyGUI::TextBox
typedef RTTIBase | Base
typedef TextBox | RTTIBase
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual const std::string & | getTypeName () const
virtual bool | isType (const std::type_info &_type) const
template<typename Type >
bool | isType () const
| ComboBox ()
size_t | getItemCount () const
| Get number of items. More...
void | insertItemAt (size_t _index, const UString &_name, Any _data=Any::Null)
| Insert an item into a array at a specified position. More...
void | addItem (const UString &_name, Any _data=Any::Null)
| Add an item to the end of a array. More...
void | removeItemAt (size_t _index)
| Remove item at a specified position. More...
void | removeAllItems ()
| Remove all items. More...
size_t | findItemIndexWith (const UString &_name)
| Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found. More...
size_t | getIndexSelected () const
| Get index of selected item (ITEM_NONE if none selected) More...
void | setIndexSelected (size_t _index)
| Select specified _index. More...
void | clearIndexSelected ()
| Clear item selection. More...
void | setItemDataAt (size_t _index, Any _data)
| Replace an item data at a specified position. More...
void | clearItemDataAt (size_t _index)
| Clear an item data at a specified position. More...
template<typename ValueType >
ValueType * | getItemDataAt (size_t _index, bool _throw=true)
| Get item data from specified position. More...
void | setItemNameAt (size_t _index, const UString &_name)
| Replace an item name at a specified position. More...
const UString & | getItemNameAt (size_t _index)
| Get item name from specified position. More...
void | beginToItemAt (size_t _index)
| Move all elements so specified becomes visible. More...
void | beginToItemFirst ()
| Move all elements so first becomes visible. More...
void | beginToItemLast ()
| Move all elements so last becomes visible. More...
void | beginToItemSelected ()
| Move all elements so selected becomes visible. More...
void | setComboModeDrop (bool _value)
| Set drop list mode (text can not be edited) More...
bool | getComboModeDrop () const
| Get drop list mode flag. More...
void | setSmoothShow (bool _value)
| Set smooth show of list. More...
bool | getSmoothShow () const
| Get smooth show of list flag. More...
void | setMaxListLength (int _value)
| Get max list length. More...
int | getMaxListLength () const
| Set max list length. More...
void | setFlowDirection (FlowDirection _value)
| Set direction, where drop down list appears (TopToBottom by default). More...
FlowDirection | getFlowDirection () const
| Get direction, where drop down list appears. More...
virtual size_t | _getItemCount ()
virtual void | _addItem (const MyGUI::UString &_name)
virtual void | _removeItemAt (size_t _index)
virtual void | _setItemNameAt (size_t _index, const UString &_name)
virtual const UString & | _getItemNameAt (size_t _index)
virtual void | _resetContainer (bool _update)
Public Member Functions inherited from MyGUI::EditBox
template<typename Type >
bool | isType () const
| EditBox ()
void | setTextIntervalColour (size_t _start, size_t _count, const Colour &_colour)
size_t | getTextSelectionStart () const
size_t | getTextSelectionEnd () const
size_t | getTextSelectionLength () const
UString | getTextInterval (size_t _start, size_t _count)
void | setTextSelection (size_t _start, size_t _end)
void | deleteTextSelection ()
UString | getTextSelection ()
bool | isTextSelection () const
void | setTextSelectionColour (const Colour &_value)
void | setTextCursor (size_t _index)
size_t | getTextCursor () const
virtual void | setCaption (const UString &_value)
virtual const UString & | getCaption ()
void | setOnlyText (const UString &_value)
UString | getOnlyText ()
size_t | getTextLength () const
void | setOverflowToTheLeft (bool _value)
| Sets if surplus characters should push characters off the left side rather than ignored. More...
bool | getOverflowToTheLeft () const
| Returns true if surplus characters will be pushed off the left rather than ignored. More...
void | setMaxTextLength (size_t _value)
| Sets the max amount of text allowed in the edit field. More...
size_t | getMaxTextLength () const
| Gets the max amount of text allowed in the edit field. More...
void | insertText (const UString &_text, size_t _index=ITEM_NONE)
void | addText (const UString &_text)
void | eraseText (size_t _start, size_t _count=1)
void | setEditReadOnly (bool _value)
bool | getEditReadOnly () const
void | setEditPassword (bool _value)
bool | getEditPassword () const
void | setEditMultiLine (bool _value)
bool | getEditMultiLine () const
void | setEditStatic (bool _value)
bool | getEditStatic () const
void | setPasswordChar (Char _value)
void | setPasswordChar (const UString &_char)
Char | getPasswordChar () const
void | setEditWordWrap (bool _value)
bool | getEditWordWrap () const
void | setTabPrinting (bool _value)
bool | getTabPrinting () const
bool | getInvertSelected ()
void | setInvertSelected (bool _value)
virtual void | setPosition (const IntPoint &_value)
virtual void | setSize (const IntSize &_value)
virtual void | setCoord (const IntCoord &_value)
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setVisibleVScroll (bool _value)
bool | isVisibleVScroll () const
size_t | getVScrollRange () const
size_t | getVScrollPosition ()
void | setVScrollPosition (size_t _index)
void | setVisibleHScroll (bool _value)
bool | isVisibleHScroll () const
size_t | getHScrollRange () const
size_t | getHScrollPosition ()
void | setHScrollPosition (size_t _index)
virtual void | setFontName (const std::string &_value)
virtual void | setFontHeight (int _value)
virtual void | setTextAlign (Align _value)
virtual void | setTextColour (const Colour &_value)
virtual IntCoord | getTextRegion ()
virtual IntSize | getTextSize ()
virtual void | setTextShadowColour (const Colour &_value)
virtual void | setTextShadow (bool _value)
Public Member Functions inherited from MyGUI::TextBox
template<typename Type >
bool | isType () const
| TextBox ()
const std::string & | getFontName ()
int | getFontHeight ()
Align | getTextAlign ()
const Colour & | getTextColour ()
void | setCaptionWithReplacing (const std::string &_value)
const Colour & | getTextShadowColour ()
bool | getTextShadow ()
Public Member Functions inherited from MyGUI::Widget
template<typename Type >
bool | isType () const
| Widget ()
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
Widget * | createWidgetT (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
template<typename T >
T * | createWidget (WidgetStyle _style, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_value)
void | setRealSize (const FloatSize &_value)
void | setRealCoord (const FloatCoord &_value)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget. More...
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _value)
float | getAlpha () const
void | setInheritsAlpha (bool _value)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount ()
Widget * | getChildAt (size_t _index)
Widget * | findWidget (const std::string &_name)
void | findWidgets (const std::string &_name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord ()
Widget * | getClientWidget ()
void | detachFromWidget (const std::string &_layer="")
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, const std::string &_layer="")
void | changeWidgetSkin (const std::string &_skinName)
void | setWidgetStyle (WidgetStyle _style, const std::string &_layer="")
WidgetStyle | getWidgetStyle () const
void | setProperty (const std::string &_key, const std::string &_value)
virtual size_t | _getItemIndex (Widget *_item)
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, const std::string &_skinName, Widget *_parent, ICroppedRectangle *_croppedParent, const std::string &_name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer ()
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
bool | _setWidgetState (const std::string &_value)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type >
bool | isType () const
template<typename Type >
Type * | castType (bool _throw=true)
template<typename Type >
const Type * | castType (bool _throw=true) const
| IObject ()
virtual | ~IObject ()
Public Member Functions inherited from MyGUI::ICroppedRectangle
| ICroppedRectangle ()
virtual | ~ICroppedRectangle ()
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
| UserData ()
virtual | ~UserData ()
void | setUserString (const std::string &_key, const std::string &_value)
const std::string & | getUserString (const std::string &_key) const
const MapString & | getUserStrings () const
bool | clearUserString (const std::string &_key)
bool | isUserString (const std::string &_key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType >
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType >
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
| WidgetInput ()
virtual | ~WidgetInput ()
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (const std::string &_value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
| SkinItem ()
ISubWidgetText * | getSubWidgetText ()
ISubWidgetRect * | getSubWidgetMain ()
void | _setTextureName (const std::string &_texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
| LayerItem ()
virtual | ~LayerItem ()
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
virtual void | attachItemToNode (ILayer *_layer, ILayerNode *_node)
virtual void | detachFromLayer ()
virtual void | upLayerItem ()
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::MemberObsolete< EditBox >
void | showVScroll (bool _visible)
bool | isShowVScroll ()
void | showHScroll (bool _visible)
bool | isShowHScroll ()
void | setTextColour (size_t _start, size_t _count, const Colour &_colour)
void | getTextSelect (size_t &_start, size_t &_end)
UString | getText (size_t _start, size_t _count)
void | setTextSelect (size_t _start, size_t _end)
void | deleteTextSelect ()
UString | getSelectedText ()
bool | isTextSelect ()
void | setTextSelectColour (const Colour &_colour)
Public Member Functions inherited from MyGUI::IItemContainer
| IItemContainer ()
virtual | ~IItemContainer ()
virtual Widget * | _getItemAt (size_t _index)
virtual void | _setItemSelected (IItem *_item)
Public Member Functions inherited from MyGUI::MemberObsolete< ComboBox >
size_t | getItemIndexSelected ()
void | setItemSelectedAt (size_t _index)
void | clearItemSelected ()
void | insertItem (size_t _index, const UString &_name)
void | setItem (size_t _index, const UString &_item)
const UString & | getItem (size_t _index)
void | deleteItem (size_t _index)
void | deleteAllItems ()
size_t | getItemSelect ()
void | resetItemSelect ()
void | setItemSelect (size_t _index)
void | setMaxListHeight (int _value)
int | getMaxListHeight ()

## Static Public Member Functions
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::EditBox
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::TextBox
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::Widget
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static const std::string & | getClassTypeName ()

## Data Fields
EventPair< EventHandle_WidgetVoid, EventHandle_ComboBoxPtrSizeT > | eventComboAccept
EventPair< EventHandle_WidgetSizeT, EventHandle_ComboBoxPtrSizeT > | eventComboChangePosition
Data Fields inherited from MyGUI::EditBox
EventPair< EventHandle_WidgetVoid, EventHandle_EditPtr > | eventEditSelectAccept
EventPair< EventHandle_WidgetVoid, EventHandle_EditPtr > | eventEditTextChange
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions
virtual void | initialiseOverride ()
virtual void | shutdownOverride ()
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | setPropertyOverride (const std::string &_key, const std::string &_value)
Protected Member Functions inherited from MyGUI::EditBox
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
void | notifyMouseSetFocus (Widget *_sender, Widget *_old)
void | notifyMouseLostFocus (Widget *_sender, Widget *_new)
void | notifyMousePressed (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseReleased (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseDrag (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseButtonDoubleClick (Widget *_sender)
void | notifyScrollChangePosition (ScrollBar *_sender, size_t _position)
void | notifyMouseWheel (Widget *_sender, int _rel)
void | updateView ()
void | updateViewWithCursor ()
void | eraseView ()
Protected Member Functions inherited from MyGUI::Widget
virtual | ~Widget ()
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer, const std::string &_name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point)
virtual void | baseUpdateEnable ()
virtual ILayerItem * | getLayerItemByPoint (int _left, int _top) const
virtual const IntCoord & | getLayerItemCoord () const
template<typename T >
void | assignWidget (T *&_widget, const std::string &_name)
VectorWidgetPtr | getSkinWidgetsByName (const std::string &_name)
void | destroySkinWidget (Widget *_widget)
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (const std::string &_state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_node, bool _deep)
void | detachFromLayerItemNode (bool _deep)
Protected Member Functions inherited from MyGUI::ScrollViewBase
| ScrollViewBase ()
virtual | ~ScrollViewBase ()
void | updateScrollSize ()
void | updateScrollPosition ()
virtual void | eraseContent ()

## Additional Inherited Members
Protected Attributes inherited from MyGUI::EditBox
bool | mIsPressed
bool | mIsFocus
bool | mCursorActive
float | mCursorTimer
float | mActionMouseTimer
size_t | mCursorPosition
size_t | mTextLength
size_t | mStartSelect
size_t | mEndSelect
DequeUndoRedoInfo | mVectorUndoChangeInfo
DequeUndoRedoInfo | mVectorRedoChangeInfo
bool | mMouseLeftPressed
bool | mModeReadOnly
bool | mModePassword
bool | mModeMultiline
bool | mModeStatic
bool | mModeWordWrap
bool | mTabPrinting
UString | mPasswordText
std::string | mOriginalPointer
Char | mCharPassword
bool | mOverflowToTheLeft
size_t | mMaxTextLength
ISubWidgetText * | mClientText
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin
ICroppedRectangle * | mCroppedParent
Protected Attributes inherited from MyGUI::ScrollViewBase
ScrollBar * | mVScroll
ScrollBar * | mHScroll
Widget * | mClient
bool | mVisibleHScroll
bool | mVisibleVScroll
size_t | mVRange
size_t | mHRange
bool | mChangeContentByResize

## Detailed Description

ComboBox properties.
Skin childs. ComboBox widget description should be here.

Definition at line 28 of file MyGUI_ComboBox.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::ComboBox::Base

Definition at line 33 of file MyGUI_ComboBox.h.

## ◆ RTTIBase

typedef ComboBox MyGUI::ComboBox::RTTIBase

Definition at line 33 of file MyGUI_ComboBox.h.

## Constructor & Destructor Documentation

## ◆ ComboBox()

MyGUI::ComboBox::ComboBox | ( |  | ) |

Definition at line 25 of file MyGUI_ComboBox.cpp.

## Member Function Documentation

## ◆ _addItem()

void MyGUI::ComboBox::_addItem | ( | const MyGUI::UString & | _name | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 565 of file MyGUI_ComboBox.cpp.

## ◆ _getItemCount()

size_t MyGUI::ComboBox::_getItemCount | ( |  | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 560 of file MyGUI_ComboBox.cpp.

## ◆ _getItemNameAt()

const UString & MyGUI::ComboBox::_getItemNameAt | ( | size_t | _index | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 580 of file MyGUI_ComboBox.cpp.

## ◆ _removeItemAt()

void MyGUI::ComboBox::_removeItemAt | ( | size_t | _index | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 570 of file MyGUI_ComboBox.cpp.

## ◆ _resetContainer()

void MyGUI::ComboBox::_resetContainer | ( | bool | _update | ) |
| virtual

Reimplemented from MyGUI::Widget.

Definition at line 585 of file MyGUI_ComboBox.cpp.

## ◆ _setItemNameAt()

void MyGUI::ComboBox::_setItemNameAt | ( | size_t | _index,
|  | const UString & | _name
| ) |  |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 575 of file MyGUI_ComboBox.cpp.

## ◆ addItem()

void MyGUI::ComboBox::addItem | ( | const UString & | _name,
|  | Any | _data = `Any::Null`
| ) |  |

Add an item to the end of a array.

Definition at line 476 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemAt()

void MyGUI::ComboBox::beginToItemAt | ( | size_t | _index | ) |

Move all elements so specified becomes visible.

Definition at line 501 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemFirst()

void MyGUI::ComboBox::beginToItemFirst | ( |  | ) |

Move all elements so first becomes visible.

Definition at line 506 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemLast()

void MyGUI::ComboBox::beginToItemLast | ( |  | ) |

Move all elements so last becomes visible.

Definition at line 512 of file MyGUI_ComboBox.cpp.

## ◆ beginToItemSelected()

void MyGUI::ComboBox::beginToItemSelected | ( |  | ) |

Move all elements so selected becomes visible.

Definition at line 518 of file MyGUI_ComboBox.cpp.

## ◆ clearIndexSelected()

void MyGUI::ComboBox::clearIndexSelected | ( |  | ) |

Clear item selection.

Definition at line 486 of file MyGUI_ComboBox.cpp.

## ◆ clearItemDataAt()

void MyGUI::ComboBox::clearItemDataAt | ( | size_t | _index | ) |

Clear an item data at a specified position.

Definition at line 491 of file MyGUI_ComboBox.cpp.

## ◆ findItemIndexWith()

size_t MyGUI::ComboBox::findItemIndexWith | ( | const UString & | _name | ) |

Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.

Definition at line 378 of file MyGUI_ComboBox.cpp.

## ◆ getClassTypeName()

static const std::string& MyGUI::ComboBox::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 33 of file MyGUI_ComboBox.h.

## ◆ getComboModeDrop()

bool MyGUI::ComboBox::getComboModeDrop | ( |  | ) | const

Get drop list mode flag.

Definition at line 524 of file MyGUI_ComboBox.cpp.

## ◆ getFlowDirection()

FlowDirection MyGUI::ComboBox::getFlowDirection | ( |  | ) | const

Get direction, where drop down list appears.

Definition at line 549 of file MyGUI_ComboBox.cpp.

## ◆ getIndexSelected()

size_t MyGUI::ComboBox::getIndexSelected | ( |  | ) | const

Get index of selected item (ITEM_NONE if none selected)

Definition at line 481 of file MyGUI_ComboBox.cpp.

## ◆ getItemCount()

size_t MyGUI::ComboBox::getItemCount | ( |  | ) | const

Get number of items.

Definition at line 471 of file MyGUI_ComboBox.cpp.

## ◆ getItemDataAt()

template<typename ValueType >

ValueType* MyGUI::ComboBox::getItemDataAt | ( | size_t | _index,
|  | bool | _throw = `true`
| ) |  |
| inline

Get item data from specified position.

Definition at line 85 of file MyGUI_ComboBox.h.

## ◆ getItemNameAt()

const UString & MyGUI::ComboBox::getItemNameAt | ( | size_t | _index | ) |

Get item name from specified position.

Definition at line 496 of file MyGUI_ComboBox.cpp.

## ◆ getMaxListLength()

int MyGUI::ComboBox::getMaxListLength | ( |  | ) | const

Set max list length.

Definition at line 544 of file MyGUI_ComboBox.cpp.

## ◆ getSmoothShow()

bool MyGUI::ComboBox::getSmoothShow | ( |  | ) | const

Get smooth show of list flag.

Definition at line 534 of file MyGUI_ComboBox.cpp.

## ◆ getTypeName()

virtual const std::string& MyGUI::ComboBox::getTypeName | ( |  | ) | const
| inlinevirtual

Get type name as string

Reimplemented from MyGUI::EditBox.

Definition at line 33 of file MyGUI_ComboBox.h.

## ◆ initialiseOverride()

void MyGUI::ComboBox::initialiseOverride | ( |  | ) |
| protectedvirtual

skin clilds:
  Button is child widget with type Button. Кнопка для выпадающего списка.

skin clilds:
  List is child widget with type ListBox. Выпадающий список.

Reimplemented from MyGUI::EditBox.

Definition at line 38 of file MyGUI_ComboBox.cpp.

## ◆ insertItemAt()

void MyGUI::ComboBox::insertItemAt | ( | size_t | _index,
|  | const UString & | _name,
|  | Any | _data = `Any::Null`
| ) |  |

Insert an item into a array at a specified position.

Definition at line 340 of file MyGUI_ComboBox.cpp.

## ◆ isType() [1/2]

template<typename Type >

bool MyGUI::ComboBox::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 33 of file MyGUI_ComboBox.h.

## ◆ isType() [2/2]

virtual bool MyGUI::ComboBox::isType | ( | const std::type_info & | _type | ) | const
| inlinevirtual

Compare with selected type

Reimplemented from MyGUI::EditBox.

Definition at line 33 of file MyGUI_ComboBox.h.

## ◆ onKeyButtonPressed()

void MyGUI::ComboBox::onKeyButtonPressed | ( | KeyCode | _key,
|  | Char | _char
| ) |  |
| protectedvirtual

Reimplemented from MyGUI::EditBox.

Definition at line 155 of file MyGUI_ComboBox.cpp.

## ◆ removeAllItems()

void MyGUI::ComboBox::removeAllItems | ( |  | ) |

Remove all items.

Definition at line 354 of file MyGUI_ComboBox.cpp.

## ◆ removeItemAt()

void MyGUI::ComboBox::removeItemAt | ( | size_t | _index | ) |

Remove item at a specified position.

Definition at line 347 of file MyGUI_ComboBox.cpp.

## ◆ setComboModeDrop()

void MyGUI::ComboBox::setComboModeDrop | ( | bool | _value | ) |

Set drop list mode (text can not be edited)

Definition at line 360 of file MyGUI_ComboBox.cpp.

## ◆ setFlowDirection()

void MyGUI::ComboBox::setFlowDirection | ( | FlowDirection | _value | ) |

Set direction, where drop down list appears (TopToBottom by default).

Definition at line 383 of file MyGUI_ComboBox.cpp.

## ◆ setIndexSelected()

void MyGUI::ComboBox::setIndexSelected | ( | size_t | _index | ) |

Select specified _index.

Definition at line 312 of file MyGUI_ComboBox.cpp.

## ◆ setItemDataAt()

void MyGUI::ComboBox::setItemDataAt | ( | size_t | _index,
|  | Any | _data
| ) |  |

Replace an item data at a specified position.

Definition at line 333 of file MyGUI_ComboBox.cpp.

## ◆ setItemNameAt()

void MyGUI::ComboBox::setItemNameAt | ( | size_t | _index,
|  | const UString & | _name
| ) |  |

Replace an item name at a specified position.

Definition at line 326 of file MyGUI_ComboBox.cpp.

## ◆ setMaxListLength()

void MyGUI::ComboBox::setMaxListLength | ( | int | _value | ) |

Get max list length.

Definition at line 539 of file MyGUI_ComboBox.cpp.

## ◆ setPropertyOverride()

void MyGUI::ComboBox::setPropertyOverride | ( | const std::string & | _key,
|  | const std::string & | _value
| ) |  |
| protectedvirtual

Properties:
  ModeDrop is ComboBox property with type bool.
  Режим выпадающего списка, в этом режиме значение в поля поменять нельзя.

Properties:
  FlowDirection is ComboBox property with type FlowDirection.
  Направление выпадения списка.

Properties:
  MaxListLength is ComboBox property with type int.
  Максимальная высота или ширина (зависит от направления) списка в пикселях.

Properties:
  SmoothShow is ComboBox property with type bool.
  Плавное раскрытие списка.

Reimplemented from MyGUI::EditBox.

Definition at line 440 of file MyGUI_ComboBox.cpp.

## ◆ setSmoothShow()

void MyGUI::ComboBox::setSmoothShow | ( | bool | _value | ) |

Set smooth show of list.

Definition at line 529 of file MyGUI_ComboBox.cpp.

## ◆ shutdownOverride()

void MyGUI::ComboBox::shutdownOverride | ( |  | ) |
| protectedvirtual

Reimplemented from MyGUI::EditBox.

Definition at line 88 of file MyGUI_ComboBox.cpp.

## Field Documentation

## ◆ eventComboAccept

EventPair<EventHandle_WidgetVoid, EventHandle_ComboBoxPtrSizeT> MyGUI::ComboBox::eventComboAccept

Event : Enter pressed in combo mode or item selected in drop down list and combo mode drop enabled (see void ComboBox::setComboModeDrop(bool _value)).
signature : void method(MyGUI::ComboBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | item

Definition at line 148 of file MyGUI_ComboBox.h.

## ◆ eventComboChangePosition

EventPair<EventHandle_WidgetSizeT, EventHandle_ComboBoxPtrSizeT> MyGUI::ComboBox::eventComboChangePosition

Event : Position changed.
signature : void method(MyGUI::ComboBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | of new position

Definition at line 155 of file MyGUI_ComboBox.h.

The documentation for this class was generated from the following files:

- MyGUI_ComboBox.h
- MyGUI_ComboBox.cpp